# PVideoOutputDeviceRGB Class Reference

This class defines a video output device for RGB in a frame store. More...

`#include <videoio.h>`

Inheritance diagram for PVideoOutputDeviceRGB:

List of all members.

## Public Member Functions

| PVideoOutputDeviceRGB ()
| Create a new video output device.
virtual PBoolean | SetColourFormat (const PString &colourFormat)
| Set the colour format to be used.
virtual PBoolean | SetFrameSize (unsigned width, unsigned height)
| Set the frame size to be used.
virtual PINDEX | GetMaxFrameBytes ()
| Get the maximum frame size in bytes.
virtual PBoolean | SetFrameData (unsigned x, unsigned y, unsigned width, unsigned height, const BYTE *data, PBoolean endFrame=true)
| Set a section of the output frame buffer.
virtual PBoolean | FrameComplete ()=0
| Indicate frame may be displayed.

## Protected Attributes

PMutex | mutex
PINDEX | bytesPerPixel
PINDEX | scanLineWidth
bool | swappedRedAndBlue

## Detailed Description

This class defines a video output device for RGB in a frame store.

## Constructor & Destructor Documentation

PVideoOutputDeviceRGB::PVideoOutputDeviceRGB | ( |  | ) |

Create a new video output device.

## Member Function Documentation

virtual PBoolean PVideoOutputDeviceRGB::FrameComplete | ( |  | ) | `[pure virtual]`

Indicate frame may be displayed.

virtual PINDEX PVideoOutputDeviceRGB::GetMaxFrameBytes | ( |  | ) | `[virtual]`

Get the maximum frame size in bytes.

Note a particular device may be able to provide variable length frames (eg motion JPEG) so will be the maximum size of all frames.

Implements PVideoDevice.

virtual PBoolean PVideoOutputDeviceRGB::SetColourFormat | ( | const PString & | colourFormat | ) | `[virtual]`

Set the colour format to be used.

Note that this function does not do any conversion. If it returns true then the video device does the colour format in native mode.

To utilise an internal converter use the SetColourFormatConverter() function.

Default behaviour sets the value of the colourFormat variable and then returns true.

Reimplemented from PVideoFrameInfo.

virtual PBoolean PVideoOutputDeviceRGB::SetFrameData | ( | unsigned | x,
|  | unsigned | y,
|  | unsigned | width,
|  | unsigned | height,
|  | const BYTE * | data,
|  | PBoolean | endFrame = `true` |
| ) |  |  | `[virtual]`

Set a section of the output frame buffer.

Implements PVideoOutputDevice.

virtual PBoolean PVideoOutputDeviceRGB::SetFrameSize | ( | unsigned | width,
|  | unsigned | height |
| ) |  |  | `[virtual]`

Set the frame size to be used.

Note that devices may not be able to produce the requested size, and this function will fail. See SetFrameSizeConverter().

Default behaviour sets the frameWidth and frameHeight variables and returns true.

Parameters:

  width | New width of frame
  height | New height of frame

Reimplemented from PVideoDevice.

## Member Data Documentation

PINDEX PVideoOutputDeviceRGB::bytesPerPixel `[protected]`

PMutex PVideoOutputDeviceRGB::mutex `[protected]`

PINDEX PVideoOutputDeviceRGB::scanLineWidth `[protected]`

bool PVideoOutputDeviceRGB::swappedRedAndBlue `[protected]`

The documentation for this class was generated from the following file:

- videoio.h